=== debian/changelog ===
hoel (1.4.8-4) unstable; urgency=medium

  * debian/tests/control: fix autopkgtest dependencies
  * debian/rules: clarify dh_auto_configure to explicitly declare options
                  build tests from cmake instead of Makefile
  * debian/control: update Standards-Version to 4.3.0 (no change)

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 05 Jan 2019 10:40:01 -0500

hoel (1.4.8-3) unstable; urgency=medium

  * debian/control: replace libmariadbclient-dev with default-libmysqlclient-dev
    (Closes: #917763)

 -- Nicolas Mora <nicolas@babelouest.org>  Sun, 30 Dec 2018 08:26:01 -0500

hoel (1.4.8-2) unstable; urgency=medium

  * debian/*install: Add pkg-config file
  * debian/*install: multiarchify files

 -- Nicolas Mora <nicolas@babelouest.org>  Sun, 16 Dec 2018 14:16:39 -0500

hoel (1.4.8-1) unstable; urgency=medium

  * New upstream release
  * Add autopkgtests suite
  * Add unit tests

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 15 Dec 2018 12:51:30 -0500
