=== debian/control ===
Source: hoel
Section: devel
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
          , Nicolas Mora <nicolas@babelouest.org>
Build-Depends: debhelper (>= 11)
             , autopkgtest (>= 5.6~)
             , dh-exec
             , liborcania-dev
             , libyder-dev
             , libjansson-dev
             , libsqlite3-dev
             , libpq-dev
             , default-libmysqlclient-dev
             , cmake
             , pkg-config
             , check
             , sqlite3
Standards-Version: 4.3.0
Homepage: https://github.com/babelouest/hoel
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/hoel.git
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/hoel.git

Package: libhoel1.4
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: database abstraction library written in C
 Simple and easy to use database access library. Works with SQLite 3,
 MariaDB/Mysql and (barely) PostgreSQL databases. Uses a json-based
 language with jansson to execute simples queries based on one table.

Package: libhoel-dev
Architecture: any
Section: libdevel
Depends: libhoel1.4 (= ${binary:Version})
       , ${misc:Depends}
       , libjansson-dev
       , liborcania-dev
       , libyder-dev
       , libsqlite3-dev
       , libpq-dev
       , default-libmysqlclient-dev
Description: database abstraction library written in C - development
 Simple and easy to use database access library. Works with SQLite 3,
 MariaDB/Mysql and (barely) PostgreSQL databases. Uses a json-based
 language with jansson to execute simples queries based on one table.
 .
 This package contains the development files.
