## hoel 1.4.16

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 # CMake file used to build all programs
 #
-# Copyright 2018 Nicolas Mora <mail@babelouest.org>
+# Copyright 2018-2020 Nicolas Mora <mail@babelouest.org>
 # Copyright 2018 Silvio Clecio <silvioprog@gmail.com>
 #
 # This program is free software; you can redistribute it and/or
@@ -28,11 +28,33 @@
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/hoel/issues")
 set(LIBRARY_VERSION_MAJOR "1")
 set(LIBRARY_VERSION_MINOR "4")
-set(LIBRARY_VERSION_PATCH "8")
-set(ORCANIA_VERSION_DOWNLOAD "1.2.9")
-set(YDER_VERSION_DOWNLOAD "1.4.4")
+set(LIBRARY_VERSION_PATCH "16")
+set(ORCANIA_VERSION_REQUIRED "2.0.1")
+set(YDER_VERSION_REQUIRED "1.4.10")
+set(JANSSON_VERSION_REQUIRED "2.4")
 
 set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
+set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
+set(PROJECT_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
+set(PROJECT_VERSION_PATCH ${LIBRARY_VERSION_PATCH})
+
+if (${LIBRARY_VERSION_MAJOR} VERSION_LESS 10)
+    set (LIBRARY_VERSION_MAJOR_PAD "0${LIBRARY_VERSION_MAJOR}")
+else ()
+    set (LIBRARY_VERSION_MAJOR_PAD "${LIBRARY_VERSION_MAJOR}")
+endif ()
+if (${LIBRARY_VERSION_MINOR} VERSION_LESS 10)
+    set (LIBRARY_VERSION_MINOR_PAD "0${LIBRARY_VERSION_MINOR}")
+else ()
+    set (LIBRARY_VERSION_MINOR_PAD "${LIBRARY_VERSION_MINOR}")
+endif ()
+if (${LIBRARY_VERSION_PATCH} VERSION_LESS 10)
+    set (LIBRARY_VERSION_PATCH_PAD "0${LIBRARY_VERSION_PATCH}")
+else ()
+    set (LIBRARY_VERSION_PATCH_PAD "${LIBRARY_VERSION_PATCH}")
+endif ()
+set(PROJECT_VERSION_NUMBER "${LIBRARY_VERSION_MAJOR_PAD}${LIBRARY_VERSION_MINOR_PAD}${LIBRARY_VERSION_PATCH_PAD}")
+
 set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")
 
@@ -75,6 +97,10 @@
     ${SRC_DIR}/hoel.c)
 
 # dependencies
+
+# pthread libraries
+find_package (Threads)
+set(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT})
 
 include(FindJansson)
 set(JANSSON_MIN_VERSION 2.4)
@@ -182,24 +208,52 @@
 endif ()
 target_link_libraries(hoel ${LIBS})
 
+# documentation
+
+option(BUILD_HOEL_DOCUMENTATION "Build the documentation." OFF)
+if (BUILD_HOEL_DOCUMENTATION)
+    find_package(Doxygen)
+    if (DOXYGEN_FOUND)
+        set(doxyfile_in ${CMAKE_CURRENT_SOURCE_DIR}/doc/doxygen.cfg)
+        set(doxyfile ${CMAKE_CURRENT_BINARY_DIR}/doxyfile)
+        
+        configure_file(${doxyfile_in} ${doxyfile} @ONLY)
+        
+        add_custom_target(doc
+                          COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile_in}
+                          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+                          COMMENT "Generating documentation with Doxygen"
+                          VERBATIM)
+
+    else ()
+        message(FATAL_ERROR "Doxygen is needed to build the documentation.")
+    endif ()
+endif ()
+
 # dependencies
+
+option(DOWNLOAD_DEPENDENCIES "Download required dependencies" ON)
 
 option(SEARCH_ORCANIA_H "Search for Orcania library" ON)
 if (SEARCH_ORCANIA_H)
     set(Orcania_FIND_QUIETLY ON) # force to find Orcania quietly
     include(FindOrcania)
-    find_package(Orcania 1.1 QUIET) # try to find orcania
+    find_package(Orcania ${ORCANIA_VERSION_REQUIRED} QUIET) # try to find orcania
     if (NOT ORCANIA_FOUND)
-        include(DownloadProject)
-        download_project(PROJ orcania # ... otherwise, download archive
-            URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_DOWNLOAD}.tar.gz"
-            QUIET)
-        add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
-        include_directories(${orcania_SOURCE_DIR}/include)
-        add_dependencies(hoel orcania)
-        set(ORCANIA_LIBRARIES orcania)
-        set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})
-        include_directories(${orcania_BINARY_DIR})
+        if (DOWNLOAD_DEPENDENCIES)
+            include(DownloadProject)
+            download_project(PROJ orcania # ... otherwise, download archive
+                URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_REQUIRED}.tar.gz"
+                QUIET)
+            add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
+            include_directories(${orcania_SOURCE_DIR}/include)
+            add_dependencies(hoel orcania)
+            set(ORCANIA_LIBRARIES orcania)
+            set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})
+            include_directories(${orcania_BINARY_DIR})
+        else ()
+            message( FATAL_ERROR "Orcania not found")
+        endif ()
     else()
         set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})
         include_directories(${ORCANIA_INCLUDE_DIRS})
@@ -215,15 +269,19 @@
     include(FindYder)
     find_package(Yder 1.1 QUIET) # try to find Yder
     if (NOT YDER_FOUND)
-        include(DownloadProject)
-        download_project(PROJ yder # ... otherwise, download archive
-                          URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_DOWNLOAD}.tar.gz"
-                          QUIET)
-        add_subdirectory(${yder_SOURCE_DIR} ${yder_BINARY_DIR})
-        include_directories(${yder_SOURCE_DIR}/include)
-        add_dependencies(hoel yder)
-        set(YDER_LIBRARIES yder orcania)
-        include_directories(${yder_BINARY_DIR})
+        if (DOWNLOAD_DEPENDENCIES)
+            include(DownloadProject)
+            download_project(PROJ yder # ... otherwise, download archive
+                              URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_REQUIRED}.tar.gz"
+                              QUIET)
+            add_subdirectory(${yder_SOURCE_DIR} ${yder_BINARY_DIR})
+            include_directories(${yder_SOURCE_DIR}/include)
+            add_dependencies(hoel yder)
+            set(YDER_LIBRARIES yder orcania)
+            include_directories(${yder_BINARY_DIR})
+        else ()
+            message( FATAL_ERROR "Yder not found")
+        endif ()
     else()
         set(LIBS ${LIBS} ${YDER_LIBRARIES})
         include_directories(${YDER_INCLUDE_DIRS})
@@ -323,56 +381,3 @@
 
 if (INSTALL_HEADER)
     set(PACKAGE_FILE_NAME
-            "lib${CMAKE_PROJECT_NAME}-dev_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
-else ()
-    set(PACKAGE_FILE_NAME
-            "lib${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
-endif ()
-set(PACKAGE_IGNORED_FILES
-        "${CMAKE_CURRENT_BINARY_DIR}/;/.git/;.gitignore;~$;${CPACK_SOURCE_IGNORE_FILES}")
-
-set(CPACK_PACKAGE_NAME "libhoel")
-set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Database abstraction library in C")
-set(CPACK_GENERATOR "TGZ;DEB")
-set(CPACK_PACKAGE_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
-set(CPACK_PACKAGE_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
-set(CPACK_PACKAGE_VERSION_PATCH ${LIBRARY_VERSION_PATCH})
-
-option(BUILD_RPM "Build a RPM for your system" OFF)
-if (BUILD_RPM)
-  set(CPACK_GENERATOR "TGZ;DEB;RPM")
-  set(CPACK_RPM_PACKAGE_LICENSE "LGPL")
-  set(CPACK_RPM_PACKAGE_URL "http://babelouest.github.io/hoel/")
-endif ()
-
-set(CPACK_DEBIAN_PACKAGE_MAINTAINER "mail@babelouest.org")
-set(CPACK_DEBIAN_PACKAGE_DESCRIPTION ${PROJECT_DESCRIPTION})
-set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/babelouest/hoel")
-set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.14), libjansson4 (>= 2.4), liborcania (>= 1.2), libyder (>= 1.3), zlib1g (>= 1:1.1.4)")
-
-if (WITH_SQLITE3)
-  set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libsqlite3-0 (>= 3.5.9)")
-endif ()
-
-if (WITH_MARIADB)
-  set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libmariadbclient18 (>= 5.5.36)")
-endif ()
-
-if (WITH_PGSQL)
-  set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libpq5 (>= 9.0~)")
-endif ()
-
-set(CPACK_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})
-
-set(CPACK_SOURCE_GENERATOR "TGZ")
-set(CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})
-set(CPACK_SOURCE_IGNORE_FILES ${PACKAGE_IGNORED_FILES})
-
-include(CPack)
-
-add_custom_target(dist_h
-        COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
-
-message(STATUS "SQLITE3 library support: ${WITH_SQLITE3}")
-message(STATUS "MariaDB library support: ${WITH_MARIADB}")
-message(STATUS "PostgreSQL library support: ${WITH_PGSQL}")
