=== debian/changelog ===
hoel (1.4.16-3) unstable; urgency=medium

  * d/tests/control: add missing dependencies
  * d/tests/unit-test: fix unit-test

 -- Nicolas Mora <nicolas@babelouest.org>  Sun, 28 Jun 2020 09:37:49 -0400

hoel (1.4.16-2) unstable; urgency=medium

  * Upload to unstable
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata (already
    present in machine-readable debian/copyright).

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 27 Jun 2020 17:53:55 -0400

hoel (1.4.16-1) experimental; urgency=medium

  * New upstream release
  * d/rules: generate doc using doxygen
  * d/libhoel-dev.docs: install documentation
  * d/patches: Fix doxygen privacy issues
  * d/control: replace debhelper with debhelper-compat
  * d/control: set compat version to 13
  * d/control: add Rules-Requires-Root: no

 -- Nicolas Mora <nicolas@babelouest.org>  Thu, 04 Jun 2020 07:36:32 -0400

hoel (1.4.15-1) experimental; urgency=medium

  * New upstream release
  * debian/control: bump standard to 4.5.0 (no changes)
  * debian/copyright: fix copyright issues
  * debian/upstream: add metadata file

 -- Nicolas Mora <nicolas@babelouest.org>  Tue, 31 Mar 2020 21:53:14 -0400

hoel (1.4.8-5) unstable; urgency=medium

  * debian/control: Add Multi-Arch: same
  * Fix shlibs warning on pthread

 -- Nicolas Mora <nicolas@babelouest.org>  Tue, 08 Jan 2019 20:28:02 -0500
