=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
           , Nicolas Mora <nicolas@babelouest.org>
-Build-Depends: debhelper (>= 11)
+Build-Depends: debhelper-compat (= 13)
              , autopkgtest (>= 5.6~)
              , dh-exec
              , liborcania-dev
@@ -17,13 +17,16 @@
              , pkg-config
              , check
              , sqlite3
-Standards-Version: 4.3.0
+             , doxygen
+Standards-Version: 4.5.0
 Homepage: https://github.com/babelouest/hoel
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/hoel.git
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/hoel.git
+Rules-Requires-Root: no
 
 Package: libhoel1.4
 Architecture: any
+Multi-Arch: same
 Section: libs
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -34,6 +37,7 @@
 
 Package: libhoel-dev
 Architecture: any
+Multi-Arch: same
 Section: libdevel
 Depends: libhoel1.4 (= ${binary:Version})
        , ${misc:Depends}
