## hoel 1.4.17

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,9 +28,9 @@
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/hoel/issues")
 set(LIBRARY_VERSION_MAJOR "1")
 set(LIBRARY_VERSION_MINOR "4")
-set(LIBRARY_VERSION_PATCH "16")
+set(LIBRARY_VERSION_PATCH "17")
 set(ORCANIA_VERSION_REQUIRED "2.0.1")
-set(YDER_VERSION_REQUIRED "1.4.10")
+set(YDER_VERSION_REQUIRED "1.4.12")
 set(JANSSON_VERSION_REQUIRED "2.4")
 
 set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
@@ -127,7 +127,7 @@
   set(_HOEL_SQLITE OFF)
 endif ()
 
-option(WITH_MARIADB "Use MariaDB/MySQL library" ON)
+option(WITH_MARIADB "Use MariaDB library" ON)
 
 if (WITH_MARIADB)
   include(FindMYSQL)
@@ -169,7 +169,7 @@
 include_directories(${PROJECT_BINARY_DIR})
 
 if (NOT WITH_PGSQL AND NOT WITH_MARIADB AND NOT WITH_SQLITE3)
-  MESSAGE(FATAL_ERROR "You must enable at least one databasse backend: Sqlite3, MariaDB/MySQL or PostgreSQL")
+  MESSAGE(FATAL_ERROR "You must enable at least one databasse backend: Sqlite3, MariaDB or PostgreSQL")
 endif ()
 
 set (PKGCONF_REQ "")
