=== debian/changelog ===
hoel (1.4.17-2) unstable; urgency=medium

  * Update package description (Closes: #983693)
  * d/copyright: update licenses

 -- Nicolas Mora <babelouest@debian.org>  Sun, 28 Feb 2021 14:07:53 -0500

hoel (1.4.17-1) unstable; urgency=medium

  * New upstream release
  * d/rules: avoid downloading dependencies if not found
  * d/control: Remove dh-exec from builddep
  * d/control: Update Standards-Version to 4.5.1

 -- Nicolas Mora <babelouest@debian.org>  Sun, 13 Dec 2020 10:51:43 -0500
