=== debian/control ===
--- 
+++ 
@@ -3,10 +3,9 @@
 Priority: optional
 Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
-          , Nicolas Mora <nicolas@babelouest.org>
+          , Nicolas Mora <babelouest@debian.org>
 Build-Depends: debhelper-compat (= 13)
              , autopkgtest (>= 5.6~)
-             , dh-exec
              , liborcania-dev
              , libyder-dev
              , libjansson-dev
@@ -18,7 +17,7 @@
              , check
              , sqlite3
              , doxygen
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://github.com/babelouest/hoel
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/hoel.git
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/hoel.git
@@ -32,7 +31,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: database abstraction library written in C
  Simple and easy to use database access library. Works with SQLite 3,
- MariaDB/Mysql and (barely) PostgreSQL databases. Uses a json-based
+ MariaDB/Mysql and PostgreSQL databases. Uses a json-based
  language with jansson to execute simples queries based on one table.
 
 Package: libhoel-dev
@@ -49,7 +48,7 @@
        , default-libmysqlclient-dev
 Description: database abstraction library written in C - development
  Simple and easy to use database access library. Works with SQLite 3,
- MariaDB/Mysql and (barely) PostgreSQL databases. Uses a json-based
+ MariaDB/Mysql and PostgreSQL databases. Uses a json-based
  language with jansson to execute simples queries based on one table.
  .
  This package contains the development files.
