=== debian/rules ===
--- 
+++ 
@@ -20,12 +20,13 @@
 	                    -DWITH_PGSQL=ON \
 	                    -DBUILD_HOEL_TESTING=ON \
 	                    -DINSTALL_HEADER=ON \
+	                    -DDOWNLOAD_DEPENDENCIES=OFF \
 	                    --no-warn-unused-cli
 
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 override_dh_auto_test:
 	sqlite3 /tmp/test.db < test/test.sqlite3.sql
-	dh_auto_test
+	dh_auto_test --
 endif
 
 override_dh_auto_build:
